﻿@{
    ViewBag.Title = "Thông báo";
    Layout = "~/Views/Shared/_Layout.cshtml";
    var getTransaction = (List<Cdio447.Models.rent_transaction>)ViewBag.getTransaction;
}
@section styles {
    <style>
        .table th {
            border-top: 0px !important;
        }
    </style>
}
@using Cdio447.Supports;
@Html.AntiForgeryToken()
<div class="row justify-content-center">
    <div class="col-12 col-lg-10">
        <div class="notification-list my-3">
            <div class="box-histories-withdrawl">
                <h4 class="text-center mb-0 pb-3" style="border-bottom: 1px solid #e74c3c">Danh sách yêu cầu thuê</h4>
                <table class="table mb-0">
                    <thead>
                        <tr>
                            <th class="table-withdraw-th">Thời gian</th>
                            <th class="table-withdraw-th">Người yêu cầu</th>
                            <th class="table-withdraw-th">Số giờ</th>
                            <th class="table-withdraw-th">Tin nhắn</th>
                            <th class="table-withdraw-th">Tình trạng</th>
                            <th class="table-withdraw-th"></th>
                        </tr>
                    </thead>
                    <tbody>
                        @if (getTransaction != null)
                        {
                            foreach (var get in getTransaction)
                            {
                                DateTime now = DateTime.Now;
                                DateTime getCreatedAt = get.created_at;
                                TimeSpan getDistance = now - getCreatedAt;
                                int checkTime = 0;
                                if (getDistance.Days >= 1 || getDistance.Hours >= 1 || getDistance.Minutes > 5)
                                {
                                    checkTime = -1;
                                }
                                <tr>
                                    <td>@FunctionSupport.convertDatetimeVN(get.created_at)</td>
                                    <td>@get.user_rent.display_name</td>
                                    <td>@get.total_time</td>
                                    <td>@get.message</td>
                                    <td>
                                        @if (checkTime == -1)
                                        {
                                            <span style="color:#8c8c8c">Đã hết thời gian xử lý</span>
                                        }
                                        else
                                        {
                                            switch (get.status)
                                            {
                                                case 1:
                                                    <span style="color:#ec7211">Đang chờ</span>
                                                    break;
                                                case 2:
                                                    <span style="color:#eb3b5a">Đã hủy</span>
                                                    break;
                                                case 3:
                                                    <span style="color: #28a745">Đã chấp nhận</span>
                                                    break;
                                            }
                                        }
                                    </td>
                                    @if (checkTime != -1 && get.status == 1 && get.user_dou.status != 2 && get.status != 3)
                                    {
                                        <td class="d-flex justify-content-center">
                                            <button class="reject_rent btn btn-danger mr-2"
                                                    data-user-id-dou="@get.user_id_dou" data-user-id-rent="@get.user_id_rent"
                                                    data-created-at="@get.created_at">
                                                Từ chối
                                            </button>
                                            <button class="accept_rent btn btn-success"
                                                    data-user-id-dou="@get.user_id_dou" data-user-id-rent="@get.user_id_rent"
                                                    data-created-at="@get.created_at">
                                                Chấp nhận
                                            </button>
                                        </td>
                                    }
                                </tr>
                            }
                        }
                        else
                        {
                            <tr>
                                <td colspan="6" class="text-danger">Chưa có giao dịch</td>
                            </tr>
                        }
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
@section scripts {
    <script>
        $('.reject_rent').on("click", function (e) {
            if (confirm("Từ chối yêu cầu thuê")) {
                var jsonPostData = {
                    __RequestVerificationToken: $('input[name=__RequestVerificationToken]').val(),
                    userIdDou: $(this).data("user-id-dou"),
                    userIdRent: $(this).data("user-id-rent"),
                    createdAt: $(this).data("created-at")
                };
                $.ajax({
                    url: "/User/Reject",
                    type: 'POST',
                    data: jsonPostData,
                    dataType: "json",
                    success: function (response) {
                        if (response == 0)
                            alert("Đã hết thời gian xử lý");
                        else if (response == 1)
                            alert("Hủy thành công");
                        else
                            alert("Có lỗi xảy ra");
                    },
                    error: function () {
                        alert("Có lỗi xảy ra");
                    },
                    complete: function () {
                        setTimeout(function () {
                            location.reload();
                        }, 500);
                    },
                });
            }
        });
        $('.accept_rent').on("click", function (e) {
            if (confirm("Chấp nhận yêu cầu thuê")) {
                var jsonPostData = {
                    __RequestVerificationToken: $('input[name=__RequestVerificationToken]').val(),
                    userIdDou: $(this).data("user-id-dou"),
                    userIdRent: $(this).data("user-id-rent"),
                    createdAt: $(this).data("created-at")
                };
                $.ajax({
                    url: "/User/Accept",
                    type: 'POST',
                    data: jsonPostData,
                    dataType: "json",
                    success: function (response) {
                        console.log(response);
                        if (response == 0)
                            alert("Đã hết thời gian xử lý");
                        else if (response == 1)
                            alert("Chấp nhận yêu cầu thuê");
                        else
                            alert("Có lỗi xảy ra");
                    },
                    error: function () {
                        alert("Có lỗi xảy ra");
                    },
                    complete: function () {
                        setTimeout(function () {
                            location.reload();
                        }, 500);
                    }
                });
            }
        });
    </script>
}